二分算法01

二分算法01

  • [1. H指数II](#1. H指数II)
  • [2. 使结果不超过阈值的最小除数](#2. 使结果不超过阈值的最小除数)
  • [3. 完成旅途的最少时间](#3. 完成旅途的最少时间)

1. H指数II

给你一个整数数组 citations ,其中 citationsi 表示研究者的第 i 篇论文被引用的次数,citations 已经按照 升序排列 。计算并返回该研究者的 h 指数。

h 指数的定义:h 代表"高引用次数"(high citations),一名科研人员的 h 指数是指他(她)的 (n 篇论文中)至少 有 h 篇论文分别被引用了至少 h 次。

请你设计并实现对数时间复杂度的算法解决此问题。

真题点击此处:275. H 指数 II

解题方法:二分查找

思路:由于数组 citations 已经按照升序排序,并且查找的范围小于数组的长度,因此可以使用二分查找。

设查找范围的初始左边界 left 为 0, 初始右边界 right 为 n−1,其中 n 为数组 citations 的长度。每次在查找范围内取中点 mid,则有 n−mid篇论文被引用了至少 citationsmid次。如果在查找过程中满足 citationsmid≥n−mid,则移动右边界 right,否则移动左边界 left。

以下为代码实现:

python 复制代码
class Solution:
    def hIndex(self, citations: List[int]) -> int:
        left, right = 0, len(citations) - 1
        n = len(citations)

        while left <= right:
            mid = (left + right)  // 2
            if citations[mid] >= n - mid:
                right = mid - 1
            else:
                left = mid + 1
            
        return n - left

时间复杂度:O(logn),使用了二分算法来查找数据。

空间复杂度:O(1),只使用了额外的常量级空间。

2. 使结果不超过阈值的最小除数

给你一个整数数组 nums 和一个正整数 threshold ,你需要选择一个正整数作为除数,然后将数组里每个数都除以它,并对除法结果求和。

请你找出能够使上述结果小于等于阈值 threshold 的除数中 最小 的那个。

每个数除以除数后都向上取整,比方说 7/3 = 3 , 10/2 = 5 。

题目保证一定有解。

真题点击此处:1283. 使结果不超过阈值的最小除数

解题方法:二分查找

思路:

1.初始化左边界 left 为1,右边界 right 为列表 nums 中的最大值。

2.进入循环,当 left 小于等于 right 时进行迭代:

  • 计算中间值 mid,为 left 和 right 的平均值。
  • 初始化变量 ans 为0,用于计算将列表中的所有数除以 mid 后的结果总和。
  • 遍历列表 nums,对每个数执行以下操作:
    • 将当前数加上 mid-1 后再除以 mid,得到向上取整的结果,并累加到 ans 中。
  • 判断 ans 是否小于等于阈值 threshold:
    • 如果是,说明当前 mid 可能是一个解,将右边界 right 更新为 mid-1。
    • 如果不是,说明当前 mid 不满足条件,将左边界 left 更新为 mid+1。

3.循环结束后,返回左边界 left。

以下为代码实现:

python 复制代码
class Solution:
    def smallestDivisor(self, nums: List[int], threshold: int) -> int:
        left, right = 1, max(nums)

        while left <= right:
            mid = (left + right) // 2
            ans = 0
            for num in nums:
                ans += (num + mid - 1) // mid
            if ans <= threshold:
                right = mid - 1
            else:
                left = mid + 1

        return left

时间复杂度:O(Nlog⁡C),其中 C是一个常数,为二分查找的上下限之差。在本题给定的数据范围的限制下,C 不会超过 10^6 。

空间复杂度:O(1)。

3. 完成旅途的最少时间

给你一个数组 time ,其中 timei 表示第 i 辆公交车完成 一趟旅途 所需要花费的时间。

每辆公交车可以 连续 完成多趟旅途,也就是说,一辆公交车当前旅途完成后,可以 立马开始 下一趟旅途。每辆公交车 独立 运行,也就是说可以同时有多辆公交车在运行且互不影响。

给你一个整数 totalTrips ,表示所有公交车 总共 需要完成的旅途数目。请你返回完成 至少 totalTrips 趟旅途需要花费的 最少 时间。

真题点击此处:2187. 完成旅途的最少时间

解题方法:二分查找

思路:

1.初始化左边界 left 为1,右边界 right 为t * totalTrips(因为最大值的时间不可能超过最小时间 * 旅途的趟数)。

2.进入循环,当 left 小于等于 right 时进行迭代:

  • 计算中间值 mid,为 left 和 right 的平均值。
  • 初始化变量 ans 为0,用于计算在 mid 时间内完成任务的总次数。
  • 遍历列表 time,对每个时间执行以下操作:
    • 将 mid 除以当前时间得到的商累加到 ans 中,表示在 mid 时间内完成当前任务的次数。
  • 判断 ans 是否小于总任务数 totalTrips:
    • 如果是,说明当前 mid 时间不足以完成所有任务,将左边界 left 更新为 mid+1。
    • 如果不是,说明当前 mid 时间足以完成所有任务,将右边界 right 更新为 mid-1。

3.循环结束后,返回左边界 left。

以下为代码实现:

python 复制代码
class Solution:
    def minimumTime(self, time: List[int], totalTrips: int) -> int:
        t = min(time)
        left, right = 1, t * totalTrips

        while left <= right:
            mid = (left + right) // 2
            ans = 0
            for t in time:
                ans += mid // t
            if ans < totalTrips:
                left = mid + 1
            else:
                right = mid - 1

        return left

时间复杂度:O(Nlog⁡C),其中 C是一个常数,为二分查找的上下限之差。

空间复杂度:O(1)。

相关推荐
行者全栈架构师3 分钟前
【鸿蒙心迹】鸿蒙网络请求架构实战——@ohos.net.http 到 Axios 封装、拦截器与统一错误处理(HarmonyOS 7.x)
前端·算法·架构
小宋102117 分钟前
OpenTelemetry GenAI可观测性实战:串起模型、工具、Token与错误
java·人工智能·算法·贪心算法
嫂子开门我是_我哥19 分钟前
青少年抑郁、焦虑、失眠与自杀相关表现的症状联系:一篇网络分析论文所使用的算法深度解读
论文阅读·算法·论文笔记
渊鱼L29 分钟前
CAD随机颗粒插件2D V2.0 更新说明
算法
Lazionr31 分钟前
unordered_map和unordered_set的使用
开发语言·c++·算法
行者全栈架构师36 分钟前
从 55% 到 6%:一个快餐营养规划器的算法迭代实录
后端·算法·架构
Laurie三省1 小时前
现场版却配上录音室版的歌词?聊聊我给开源 Mac 歌词软件写的多源打分算法
算法·macos·go
对空六课1 小时前
Vue 组件曝光埋点为什么会重复触发?去重方案与实现思路
服务器·前端·算法·数据分析
HZY1618yzh1 小时前
下一代编程语言出炉
c++·算法
CoderYanger1 小时前
A.每日一题:856. 括号的分数
java·程序人生·算法·leetcode·面试·职场和发展·学习方法